#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/sched.h>
#include <linux/sched/signal.h>

MODULE_DESCRIPTION("LKM1");
MODULE_AUTHOR("CS695");
MODULE_LICENSE("GPL");

static __init int print_runnable_processes(void)
{
	struct task_struct *task;
	pr_info("[LKM1] Runnable Processes:\n");
	pr_info("[LKM1] PID\tPROC\n");
	pr_info("[LKM1] ------------------\n");
	for_each_process(task) {
		if (task_is_running(task)) {
			pr_info("[LKM1] %d\t%s\n", task -> pid, task->comm);
		}
	}
	return 0;
}

static __exit void exit_module(void)
{
	pr_info("[LKM1] Module LKM1 Unloaded\n");
}

module_init(print_runnable_processes);
module_exit(exit_module);
