#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/sched.h>

MODULE_DESCRIPTION("LKM2");
MODULE_AUTHOR("CS695");
MODULE_LICENSE("GPL");

static int pid=1;
module_param(pid, int, 0);
MODULE_PARM_DESC(pid, "PID of the parent process");


char* task_state(long state){
    switch(state){
        case TASK_RUNNING:
            return "TASK_RUNNING";
        case TASK_INTERRUPTIBLE:
            return "TASK_INTERRUPTIBLE";
        case TASK_UNINTERRUPTIBLE:
            return "TASK_UNINTERRUPTIBLE";
        case __TASK_STOPPED:
            return "TASK_STOPPED";
        case __TASK_TRACED:
            return "TASK_TRACED";
        default:
            return "OTHER STATE";
    }
}

static int print_child_processes(void)
{
    struct task_struct *p_task = NULL;
    struct task_struct *tsk = NULL;
    rcu_read_lock();

	p_task = pid_task(find_vpid(pid), PIDTYPE_PID);

	if (p_task == NULL) {
		pr_info("[LKM2] Parent Process with PID: %d not found\n", pid);
            rcu_read_unlock();
		return 0;
	}
	list_for_each_entry_rcu(tsk, &p_task->children, sibling) {
		pr_info("[LKM2] Child Process PID: %d, State: %d/%d/%s\n", tsk->pid, tsk->__state, task_state_index(tsk), task_state(task_state_index(tsk)));
	}

	rcu_read_unlock();
	return 0;
}

static void __exit exit_module(void)
{
    pr_info("[LKM2] Module LKM2 Unloaded\n");
}

module_init(print_child_processes);
module_exit(exit_module);
