#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/mman.h>

#include "chardev.h"


int main(){
	char* mem = malloc(1);
	*mem = 6;

	int fd = open("/dev/chardev",O_RDWR);
	
	if(fd < 0){
		perror("Error in opening ioctl driver file\n");
		return -1;
	}
	
	printf("Virtual Address: 0x%llx\tValue: %d\n",(long long unsigned int)mem, *mem);
	
	struct query_arg_t translate_query;
	translate_query.virt_addr = (unsigned long)mem;
	
	int ret = ioctl(fd,IOCTL_PHYS_TO_VIRT,&translate_query);
	if (ret != 0){
		perror("Error in ioctl\n");
		return -1;
	}
	
	printf("Physical Address: 0x%llx\tValue: %d\n",(long long unsigned int)(translate_query.phys_addr), *mem);

	
	struct query_arg_t write_query;
	
	write_query.phys_addr = translate_query.phys_addr;
	write_query.byte_val = 5;
	
	ret = ioctl(fd,IOCTL_WRITE_TO_PHYS,&write_query);
	if (ret != 0){
		perror("Error in ioctl\n");
		return -1;
	}

	printf("Virtual Address: 0x%llx\tValue: %d\n",(long long unsigned int)mem, *mem);
	
	close(fd);
	free(mem);

	return 0;
}
